<?php
/***************************************************************************
 *                            topics_anywhere.php
 *                            -------------------
 *   begin                : Wednesday, Aug 28, 2002
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: topics_anywhere.php,v 1.11.0 2003/09/01 14:32:00 DtM Exp $
 *
 *
 *                              VIDON Release 2
 *                                www.vidon.ru
 *                                2005/08/08
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/
if ( !defined('IN_PHPBB') )
{
        die("Hacking attempt");
        exit;
}

include($phpbb_root_path . 'common.'.$phpEx);

include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_main.' . $phpEx);
include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_topics_anywhere.' . $phpEx);

$server_protocol = ($board_config['cookie_secure']) ? 'https://' : 'http://';
$server_name = preg_replace('#^\/?(.*?)\/?$#', '\1', trim($board_config['server_name']));
$server_port = ($board_config['server_port'] <> 80) ? ':' . trim($board_config['server_port']) : '';
$script_location = preg_replace('#^\/?(.*?)\/?$#', '\1', trim($board_config['script_path']));
$script_location = ($script_location == '') ? $script_location : '/' . $script_location;

$full_url = $server_protocol . $server_name . $server_port . $script_location;

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);
//
// End session management
//

$lang['Topics_anywhere'] = 'Topics Anywhere';

define('TA_SCRIPT_NAME', 'topics_anywhere');
define('TA_VERSION', 'VR2');

$lastpostby_formats = array($lang['Username'], $lang['Lastpost_from'] . ' ' . $lang['Username']);

// General functions
function output_die($msg)
{
	global $out, $phpEx, $full_url, $version;

	$error = true;

	if ($out == 'js')
	{
		if (is_array($msg))
		{
			$output = implode('<br>', $msg);
		}
		else
		{
			$output = $msg;
		}

		$output = '<b>' . $output . '<br>' . sprintf($lang['Error'], TA_SCRIPT_NAME . $phpEx) . '</b><br><br>TA_VERSION ' . TA_VERSION;
		exit("document.writeln('$output');\n");
	}
	else if ($out == 'rss')
	{
		$output = generate_rss_header($version);

		$link = ($version == '0.91') ? substr($full_url, 0, 500) : $full_url;

		if (is_array($msg))
		{
			while ($error = array_shift($msg))
			{
				$output .= '<item>' . "\n";;
				$output .= '<title>' . $error . '</title>' . "\n";
				$output .= '<link>' . $link . '</link>' . "\n";
				$output .= '<description>' . sprintf($lang['Error'], TA_SCRIPT_NAME . $phpEx) . ' (TA_VERSION ' . TA_VERSION . ')</description>' . "\n";
				$output .= '</item>' . "\n";
			}
		}
		else
		{
			$output .= '<item>' . "\n";;
			$output .= '<title>' . $msg . '</title>' . "\n";
			$output .= '<link>' . $link . '</link>' . "\n";
			$output .= '<description>' . sprintf($lang['Error'], TA_SCRIPT_NAME . $phpEx) . ' (TA_VERSION ' . TA_VERSION . ')</description>' . "\n";
			$output .= '</item>' . "\n";
		}

		$output .= generate_rss_footer();

		header("Content-type: text/xml");
		exit($output);
	}
}

function forum_select() // generates select of all available forums (modified make_jumpbox()-function)
{
	global $template, $lang, $db, $SID, $nav_links, $phpEx, $hide_forums;

	$sql = "SELECT c.cat_id, c.cat_title, c.cat_order
		FROM " . CATEGORIES_TABLE . " c, " . FORUMS_TABLE . " f
		WHERE f.cat_id = c.cat_id
		GROUP BY c.cat_id, c.cat_title, c.cat_order
		ORDER BY c.cat_order";
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, "Couldn't obtain category list.", "", __LINE__, __FILE__, $sql);
	}

	$category_rows = array();
	while ( $row = $db->sql_fetchrow($result) )
	{
		$category_rows[] = $row;
	}

	if ( $total_categories = count($category_rows) )
	{
		$sql = "SELECT *
			FROM " . FORUMS_TABLE . "
			ORDER BY cat_id, forum_order";
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not obtain forums information', '', __LINE__, __FILE__, $sql);
		}

		$forum_rows = array();
		while ( $row = $db->sql_fetchrow($result) )
		{
			$forum_rows[] = $row;
		}

		$boxstring = '<select multiple name="' . POST_FORUM_URL . '[]" size=6>';

		if ( $total_forums = count($forum_rows) )
		{
			for($i = 0; $i < $total_categories; $i++)
			{
				$boxstring_forums = '';
				for($j = 0; $j < $total_forums; $j++)
				{
					if ( $forum_rows[$j]['cat_id'] == $category_rows[$i]['cat_id'])
					{
						if (!in_array($forum_rows[$j]['forum_id'], $hide_forums))
						{
							$boxstring_forums .=  '<option value="' . $forum_rows[$j]['forum_id'] . '">' . $forum_rows[$j]['forum_name'] . '</option>';
						}
					}
				}

				if ( $boxstring_forums != '')
				{
					if ($i != 0)
					{
						$boxstring .= '<option value="-1">&nbsp;</option>';
					}
					$boxstring .= '<option value="cat' . $category_rows[$i]['cat_id'] . '">' . $category_rows[$i]['cat_title'] . '</option>';
					$boxstring .= '<option value="-1">----------------</option>';
					$boxstring .= $boxstring_forums;
				}
			}
		}

		$boxstring .= '</select>';
	}
	else
	{
		$boxstring .= '<select multiple name="' . POST_FORUM_URL . '[]" size=1></select>';
	}
	$data = array($boxstring, $total_forums);
	return $data;
}

function bullet_select($bullets) // generates select of all available bullets from array $bullets
{
	global $lang;
	$select = '<select name="bullet_type">';
	$select .= '<option value="non">' . $lang['None'] . '</option>';
	$select .= '<option value="dis">HTML ' . $lang['disc'] . '</option>';
	$select .= '<option value="cir">HTML ' . $lang['circle'] . '</option>';
	$select .= '<option value="squ">HTML ' . $lang['square'] . '</option>';
	$select .= '<option value="num">HTML ' . $lang['numbered'] . '</option>';
	for ($i = 0; $i < count($bullets); $i++)
	{
		$select .= '<option value="' . $i . '">' . $bullets[$i] . '</option>';
	}
	$select .= '</select>';
	return $select;
}

function lastpostby_select($lastpostby_formats) // generates select of "last post by" text formats
{
	global $lang;
	$select = '<select name="lastpostby_format">';
	for ($i = 0; $i < count($lastpostby_formats); $i++)
	{
		$select .= '<option value="' . $i . '">' . $lastpostby_formats[$i] . '</option>';
	}
	$select .= '</select>';
	return $select;
}

function lastpostdate_select($date_formats) // generates select of date formats from array $dateformats
{
	global $lang;
	$now = time();
	$select = '<select name="lastpostdate_format">';
	for ($i = 0; $i < count($date_formats); $i++)
	{
		$select .= '<option value="' . $i . '">' . create_date($date_formats[$i], $now, $board_config['board_timezone']) . '</option>';
	}
	$select .= '</select>';
	return $select;
}

function output_select()
{
	$select = '<select name="out">';
	$select .= '<option value="js">JavaScript</option>';
	$select .= '<option value="rss0.91">RSS 0.91</option>';
	$select .= '<option value="rss2.0">RSS 2.0</option>';
	$select .= '</select>';
	return $select;
}

function show_the_page()
{
	global $userdata, $template, $lang, $db, $SID, $nav_links, $phpEx, $phpbb_root_path, $theme, $images, $date_formats, $lastpostby_formats, $bullets, $board_config, $full_url;

	$page_title = $lang['Topics_anywhere'];

        include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_admin.' . $phpEx);

        include($phpbb_root_path . 'includes/page_header.'.$phpEx);

	$template->set_filenames(array(
		'body' => 'topics_anywhere_body.tpl')
	);

	$outputarray = forum_select();

	if ($board_config['allow_html'])
	{
		$html_allowed_append = ' (' . strip_tags($lang['HTML_is_ON']) . ' - ' . $lang['Allowed_tags'] . ': &lt;' . str_replace(',', '&gt;, &lt;', $board_config['allow_html_tags']) . '&gt;)';
	}
	else
	{
		$html_allowed_append = ' (' . strip_tags($lang['HTML_is_OFF']) . ')';
	}

	$template->assign_vars(array(
		'L_TOPICS_ANYWHERE' => $lang['Topics_anywhere'] . ' ' . TA_VERSION,
		'L_TOPICS_ANYWHERE_EXPLAIN' => $lang['Topics_anywhere_explain'] . ' ' . $lang['Topics_anywhere_explain_more'],
		'L_OUTPUT' => $lang['Output'],
		'L_OUTPUT_EXPLAIN' => $lang['Output_explain'],
		'OUTPUT_SELECT' => output_select($languages, $langs),
		'L_SELECT_FORUM' => $lang['Forum_select'] . $lang['Category_select'],
		'L_SELECT_FORUM_EXPLAIN' => $lang['Select_forum_explain'] . $lang['Category_explain'],
		'SELECT_FORUM_SELECT' => $outputarray[0],
		'L_OR' => $lang['Or'],
		'L_CHECK_ALLFORA' => $lang['All_available'],
		'L_AMOUNT_TOPICS' => $lang['Amount_topics'],
		'L_AMOUNT_TOPICS_EXPLAIN' => $lang['Amount_topics_explain'],
		'L_TOPICS_LIFESPAN' => $lang['Topics_lifespan'],
		'L_TOPICS_LIFESPAN_EXPLAIN' => $lang['Topics_lifespan_explain'],
		'L_TOPICS_LIFESPAN_NOREPLY' => $lang['Topics_lifespan_noreply'],
		'L_TOPICS_LIFESPAN_STARTDATE' => $lang['Topics_lifespan_startdate'],
		'L_HOURS' => strtolower($lang['Hours']),
		'L_DAYS' => strtolower($lang['Days']),
		'L_JUMP_LAST_POST' => $lang['Url_last_post'],
		'L_JUMP_LAST_POST_EXPLAIN' => $lang['Url_last_post_explain'],
		'L_SHOW_FORUM_NAME' => $lang['Show_forum_name'],
		'L_SHOW_FORUM_NAME_EXPLAIN' => $lang['Show_forum_name_explain'],
		'L_LINK_FORUM_NAME' => $lang['Link_forum_name'],
		'L_LINK_FORUM_NAME_EXPLAIN' => $lang['Link_forum_name_explain'] . ' (*)',
		'L_SHOW_REPLIES' => $lang['Show_replies'],
		'L_SHOW_REPLIES_EXPLAIN' => $lang['Show_replies_explain'],
		'L_SHOW_REPLIES_WORD' => $lang['Show_replies_word'],
		'L_SHOW_REPLIES_WORD_EXPLAIN' => $lang['Show_replies_word_explain'],
		'L_SHOW_ANNOUNCEMENTS' => $lang['Show_announce'],
		'L_SHOW_STICKYS' => $lang['Show_sticky'],
		'L_SHOW_LOCKED' => $lang['Show_locked'],
		'L_SHOW_MOVED' => $lang['Show_moved'],
		'L_SHOW_REGULAR' => $lang['Show_regular'],
		'L_HIDE_LABELS' => $lang['Hide_labels'],
		'L_HIDE_LABELS_EXPLAIN' => $lang['Hide_labels_explain'],
		'O_ANNOUNCEMENT' => strip_tags($lang['Topic_Announcement']),
		'O_STICKY' => strip_tags($lang['Topic_Sticky']),
		'O_MOVED' => strip_tags($lang['Topic_Moved']),
		'O_POLL' => strip_tags($lang['Topic_Poll']),
		'O_LOCKED' => strip_tags($lang['Topic_Locked']),
		'L_SORT_ORDER' => $lang['Sort_order'],
		'L_SORT_ORDER_EXPLAIN' => $lang['Sort_order_explain'],
		'O_PRIORITY' => $lang['Priority'],
		'O_ON_DATE' => $lang['On_date'],
		'L_BULLET_TYPE' => $lang['Bullet_type'],
		'L_BULLET_TYPE_EXPLAIN' => $lang['Bullet_type_explain'] . ' (*)',
		'BULLET_TYPE_SELECT' => bullet_select($bullets),
		'L_SHOW_LASTPOSTBY' => $lang['Show_lastpostby'],
		'L_SHOW_LASTPOSTBY_EXPLAIN' => $lang['Show_lastpostby_explain'],
		'L_LASTPOSTBY_FORMAT' => $lang['Lastpostby_format'],
		'L_LASTPOSTBY_FORMAT_EXPLAIN' => $lang['Lastpostby_format_explain'],
		'LASTPOSTBY_FORMAT_SELECT' => lastpostby_select($lastpostby_formats),
		'L_SHOW_LASTPOSTDATE' => $lang['Show_lastpostdate'],
		'L_SHOW_LASTPOSTDATE_EXPLAIN' => $lang['Show_lastpostdate_explain'],
		'L_LASTPOSTDATE_FORMAT' => $lang['Lastpostdate_format'],
		'L_LASTPOSTDATE_FORMAT_EXPLAIN' => $lang['Lastpostdate_format_explain'],
		'LASTPOSTDATE_FORMAT_SELECT' => lastpostdate_select($date_formats),
		'L_SHOW_LASTPOSTICON' => $lang['Show_lastposticon'],
		'L_SHOW_LASTPOSTICON_EXPLAIN' => $lang['Show_lastposticon_explain'] . ' (*)',
		'L_LASTPOSTICON_AS_BULLET' => $lang['Lastposticon_as_bullet'],
		'L_LASTPOSTICON_AS_BULLET_EXPLAIN' => $lang['Lastposticon_as_bullet_explain'] . ' (*)',
		'L_ADD_BREAK' => $lang['Add_break'],
		'L_ADD_BREAK_EXPLAIN' => $lang['Add_break_explain'] . ' (*)',
		'L_ADD_BLANK_LINE' => $lang['Add_blank_line'],
		'L_ADD_BLANK_LINE_EXPLAIN' => $lang['Add_blank_line_explain'] . ' (*)',
		'L_LIMIT_LENGTH' => $lang['Limit_title_length'],
		'L_LIMIT_LENGTH_EXPLAIN' => $lang['Limit_title_length_explain'],
		'L_LIMIT_WHERE' => $lang['Limit_title_where'],
		'L_LIMIT_WHERE_EXPLAIN' => $lang['Limit_title_where_explain'],
		'L_PREVIOUS_SPACE' => $lang['Limit_title_previous_space'],
		'L_EXACT' => $lang['Limit_title_exact'],
		'L_NEXT_SPACE' => $lang['Limit_title_next_space'],
		'L_CSS_LINK' => $lang['CSS_link'],
		'L_CSS_LINK_EXPLAIN' => $lang['CSS_link_explain'] . ' (*)',
		'L_CSS_TEXT' => $lang['CSS_text'],
		'L_CSS_TEXT_EXPLAIN' => $lang['CSS_text_explain'] . ' (*)',
		'L_TARGET_LINK' => $lang['Target_link'],
		'L_TARGET_LINK_EXPLAIN' => $lang['Target_link_explain'] . ' (*)',
		'L_ADV_FORM' => $lang['Advanced_formatter'],
		'L_ADV_FORM_EXPLAIN' => $lang['Advanced_formatter_explain'],
		'L_ADV_FORM_STRING' => $lang['Advanced_formatter_string'],
		'L_ADV_FORM_STRING_EXPLAIN' => $lang['Advanced_formatter_string_explain'],
		'L_ADV_FORM_DEFAULT' => 'lbl tt fn rep - lpa, lpt lpi',
		'L_ADV_FORM_VARS' => $lang['Advanced_formatter_variables'] . '<br /><br />' . $lang['Advanced_formatter_variables_extra'] . $html_allowed_append,
		'L_YES' => $lang['Yes'],
		'L_NO' => $lang['No'],
		'L_SUBMIT' => $lang['Submit'],
		'L_RESET' => $lang['Reset'],
		'H_TOTAL_FORUMS' => $outputarray[1],
		'S_FORM_ACTION' => append_sid(TA_SCRIPT_NAME . ".$phpEx?mode=generate"))
	);

	$template->pparse('body');
        echo ("<div align=\"center\"><span class=\"copyright\">Powered by VR <a href=\"http://www.vidon.ru/\" title=\" .  \" target=\"_phpbb\" class=\"copyright\"><span class=\"copyright\">Vidon.RU</span></a></span></div>");
	include($phpbb_root_path . 'includes/page_tail.'.$phpEx);
}

function generate_rss_header($version)
{
	global $db, $lang, $board_config, $full_url;

	$sql = "SELECT template_name
		FROM " . THEMES_TABLE . "
		WHERE themes_id = " . $board_config['default_style'];
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(CRITICAL_ERROR, 'Could not query database for theme info');
	}

	if ( !($row = $db->sql_fetchrow($result)) )
	{
		message_die(CRITICAL_ERROR, "Could not get theme data for themes_id [$style]");
	}

	$dir = $row['template_name'];

	$langs = array('albanian', 'arabic', 'bulgarian', 'catalan', 'chinese_simplified', 'chinese_traditional', 'croatian', 'czech', 'danish', 'dutch', 'english', 'finnish', 'french', 'galego', 'german', 'german_sie', 'greek', 'hebrew', 'hungarian', 'icelandic', 'indonesian', 'italian', 'japanese', 'korean', 'kurdish', 'lithuanian', 'macedonian', 'norwegian', 'polish', 'portuguese', 'portuguese_brazil', 'romanian', 'romanian_no_diacritics', 'russian', 'russian_tu', 'serbian', 'slovak', 'slovenian', 'spanish', 'spanish_argentina', 'swedish', 'thai', 'turkish', 'ukrainian', 'welsh');
	$codes = array('SQ', 'AR', 'BG', 'CA', 'ZH-CN', 'ZH-TW', 'HR', 'CS', 'DA', 'NL', 'EN', 'FI', 'FR', 'GL', 'DE', 'DE', 'EL', 'HE', 'HU', 'IS', 'ID', 'IT', 'JA', 'KO', 'KU', 'LT', 'MK', 'NO', 'PL', 'PT', 'PT-BR', 'RO', 'RO', 'RU', 'RU', 'SR', 'SK', 'SL', 'ES', 'ES-AR', 'SV', 'TH', 'TR', 'UK', 'CY');

	if (($index = array_search($board_config['default_lang'], $langs)) !== FALSE) {
		$langcode = strtolower($codes[$index]);
	}
	else
	{
		$langcode = 'en';
	}

	unset($langs, $codes, $index);

	$title = ($version == '0.91') ? substr($board_config['sitename'], 0, 100) : $board_config['sitename'];
	$link = ($version == '0.91') ? substr($full_url, 0, 500) : $full_url;
	$description = ($version == '0.91') ? substr($board_config['site_desc'], 0, 500) : $board_config['site_desc'];
	$url = ($version == '0.91') ? substr(($full_url . '/templates/' . $dir . '/images/logo_phpBB.gif'), 0, 500) : ($full_url . '/templates/' . $dir . '/images/logo_phpBB.gif');
	$copy = ($version == '0.91') ? substr(('Copyright ' . date('Y', $board_config['board_startdate']) . '-' . date('Y') . ', ' . $board_config['sitename']), 0, 100) : ('Copyright ' . date('Y', $board_config['board_startdate']) . '-' . date('Y') . ', ' . $board_config['sitename']);
	$mail = ($version == '0.91') ? substr($board_config['board_email'], 0, 100) : $board_config['board_email'];
	$docs = ($version == '0.91') ? 'http://backend.userland.com/stories/rss091' : 'http://blogs.law.harvard.edu/tech/rss';
	$date = date('r');

	$output = '<?xml version="1.0" encoding="' . $lang['ENCODING'] . '" ?>' . "\n";
	$output .= '<rss version="' . $version . '">' . "\n";
	$output .= '<channel>' . "\n";
	$output .= '<title>' . $title . '</title>' . "\n";
	$output .= '<link>' . $link . '</link>' . "\n";
	$output .= '<description>' . $description . '</description>' . "\n";
	$output .= '<language>' . $langcode . '</language>' . "\n";
	$output .= '<managingEditor>' . $mail . '</managingEditor>' . "\n";
	$output .= '<webMaster>' . $mail . '</webMaster>' . "\n";
	$output .= '<pubDate>' . $date . '</pubDate>' . "\n";
	$output .= '<lastBuildDate>' . $date . '</lastBuildDate>' . "\n";
	$output .= '<copyright>' . $copy . '</copyright>' . "\n";

	if ($version == '2.0')
	{
		$output .= '<generator>' . $lang['Topics_anywhere'] . ' ' . TA_VERSION . '</generator>' . "\n";
	}

	$output .= '<docs>' . $docs . '</docs>' . "\n";

	$output .= '<image>' . "\n";
	$output .= '<url>' . $url . '</url>' . "\n";
	$output .= '<title>' . $title . '</title>' . "\n";
	$output .= '<link>' . $link . '</link>' . "\n";
	$output .= '</image>' . "\n";

	return $output;
}

function generate_rss_footer()
{
	$output = '</channel>' . "\n";
	$output .= '</rss>' . "\n";

	return $output;
}


if ($public_only) // adds all non-public forum id's to the $hide_forums array so they can't be used
{
	$sql = "SELECT * FROM " . USERS_TABLE . " WHERE user_id = " . ANONYMOUS;
	if (!($result = $db->sql_query($sql)))
	{
		message_die(CRITICAL_ERROR, 'Could not obtain user data from user table', '', __LINE__, __FILE__, $sql);
	}

	$userdata2 = $db->sql_fetchrow($result);

	$db->sql_freeresult($result);

	$auth_ary = auth(AUTH_READ, AUTH_LIST_ALL, $userdata2);

	$public_forums = array();
	while (list($auth_forum_id, $auth_level) = each($auth_ary))
	{
		if ($auth_level['auth_read'])
		{
			array_push($public_forums, $auth_forum_id);
		}
	}

	$sql = "SELECT forum_id FROM " . FORUMS_TABLE . " ORDER BY forum_id";
	if (!($result = $db->sql_query($sql)))
	{
		message_die(GENERAL_ERROR, 'Could not obtain forums information', '', __LINE__, __FILE__, $sql);
	}

	$all_forums = array();
	while ($row = $db->sql_fetchrow($result))
	{
		array_push($all_forums, $row['forum_id']);
	}
	$db->sql_freeresult($result);

	for ($i = 0; $i < count($all_forums); $i++) {
		if (in_array($all_forums[$i], $public_forums)) {
			array_splice($all_forums, $i, 1);
			$i--;
		}
	}

	$hide_forums = array_merge($hide_forums, $all_forums);
	$hide_forums = array_unique($hide_forums);
}

if ($HTTP_GET_VARS['mode'] == "generate") // generate and show the code that the user has to put into the page where the topics are to be displayed
{
	$htmlstring = $full_url . '/' . TA_SCRIPT_NAME . '.' . $phpEx . '?mode=show';

	$out = 'js';

	if ($HTTP_POST_VARS['out'] != 'js')
	{
		$out = $HTTP_POST_VARS['out'];
		$htmlstring .= '&out=' . $out;
	}

	if (isset($HTTP_POST_VARS['f']))
	{
		$farray = $HTTP_POST_VARS['f'];
	}
	else
	{
		$farray = array();
	}

	$carray = array();

	if (count($farray) != 0)
	{
		$farray = array_unique($farray);
		sort($farray);
		for ($j = 0; $j < count($farray); $j++) {
			if ($farray[$j] == '-1') {
				array_splice($farray, $j, 1);
			}
		}

		for ($j = 0; $j < count($farray); $j++) {
			if (strpos($farray[$j], 'cat') !== false) {
				$carray = array_merge($carray, array_splice($farray, $j, 1));
				$j--;
			}
		}
	}

	if (count($carray) != 0)
	{
		$carray = str_replace('cat', '', $carray);
		$catsql = '(' . implode(', ', $carray) . ')';

		$sql = "SELECT forum_id
			FROM " . FORUMS_TABLE . "
			WHERE cat_id IN " . $catsql . "
			ORDER BY forum_id";
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not obtain forums information', '', __LINE__, __FILE__, $sql);
		}

		$carray = array();
		while ( $row = $db->sql_fetchrow($result) )
		{
			$carray[] = $row['forum_id'];
		}

		$farray = array_merge($farray, $carray);
		$farray = array_unique($farray);
		sort($farray);
	}

	if (count($farray) == 0 && !$HTTP_POST_VARS['allfora'])
	{
		message_die(GENERAL_ERROR, ($lang['Pick_a_forum'] . '<br /><br /><a href="javascript:history.back()">' . $lang['Click_return'] . '</a>'));
	}
	else
	{
		if ($HTTP_POST_VARS['allfora'] || ($HTTP_POST_VARS['total_forums'] == count($farray)))
		{
			$htmlstring .= '&f=a';
		}
		else
		{
			if (count($farray) == 1)
			{
				$htmlstring .= '&f=' . $farray[0];
			}
			else
			{
				$htmlstring .= '&f=u' . rawurlencode(base64_encode(implode(',', $farray)));
			}
		}
	}

	if (!isset($HTTP_POST_VARS['amount_topics']))
	{
		message_die(GENERAL_ERROR, ($lang['Invalid_amount'] . '<br /><br /><a href="javascript:history.back()">' . $lang['Click_return'] . '</a>'));
	}
	else
	{
		if (!is_numeric($HTTP_POST_VARS['amount_topics']))
		{
			message_die(GENERAL_ERROR, ($lang['Invalid_amount'] . '<br /><br /><a href="javascript:history.back()">' . $lang['Click_return'] . '</a>'));
		}
		else
		{
			$amount = floor(intval($HTTP_POST_VARS['amount_topics']));
			if ($amount > 0)
			{
				$htmlstring .= '&n=' . $amount;
			}
			else
			{
				message_die(GENERAL_ERROR, ($lang['Invalid_amount'] . '<br /><br /><a href="javascript:history.back()">' . $lang['Click_return'] . '</a>'));
			}
		}
	}

	if ($HTTP_POST_VARS['noreply'])
	{
		if (!isset($HTTP_POST_VARS['noreply_timespan']))
		{
			message_die(GENERAL_ERROR, ($lang['Invalid_timespan'] . '<br /><br /><a href="javascript:history.back()">' . $lang['Click_return'] . '</a>'));
		}
		else
		{
			if (!is_numeric($HTTP_POST_VARS['noreply_timespan']))
			{
				message_die(GENERAL_ERROR, ($lang['Invalid_timespan'] . '<br /><br /><a href="javascript:history.back()">' . $lang['Click_return'] . '</a>'));
			}
			else
			{
				$timespan = floor(intval($HTTP_POST_VARS['noreply_timespan']));
				if ($timespan > 0)
				{
					if ($HTTP_POST_VARS['noreply_unit'] == 'day')
					{
						$timespan = $timespan * 864;
					}
					else
					{
						$timespan = $timespan * 36;
					}
					$htmlstring .= '&hnr=' . $timespan;
				}
				else
				{
					message_die(GENERAL_ERROR, ($lang['Invalid_timespan'] . '<br /><br /><a href="javascript:history.back()">' . $lang['Click_return'] . '</a>'));
				}
			}
	}
	}

	if ($HTTP_POST_VARS['startdate'])
	{
		if (!isset($HTTP_POST_VARS['startdate_timespan']))
		{
			message_die(GENERAL_ERROR, ($lang['Invalid_timespan'] . '<br /><br /><a href="javascript:history.back()">' . $lang['Click_return'] . '</a>'));
		}
		else
		{
			if (!is_numeric($HTTP_POST_VARS['startdate_timespan']))
			{
				message_die(GENERAL_ERROR, ($lang['Invalid_timespan'] . '<br /><br /><a href="javascript:history.back()">' . $lang['Click_return'] . '</a>'));
			}
			else
			{
				$timespan = floor(intval($HTTP_POST_VARS['startdate_timespan']));
				if ($timespan > 0)
				{
					if ($HTTP_POST_VARS['startdate_unit'] == 'day')
					{
						$timespan = $timespan * 864;
					}
					else
					{
						$timespan = $timespan * 36;
					}
					$htmlstring .= '&hsd=' . $timespan;
				}
				else
				{
					message_die(GENERAL_ERROR, ($lang['Invalid_timespan'] . '<br /><br /><a href="javascript:history.back()">' . $lang['Click_return'] . '</a>'));
				}
			}
		}
	}

	if ($HTTP_POST_VARS['jump_last_post'])
	{
		$htmlstring .= '&jlp=y';
	}

	if ($HTTP_POST_VARS['show_forum_name'])
	{
		$htmlstring .= '&sfn=y';
		if ($HTTP_POST_VARS['link_forum_name'] && $out == 'js')
		{
			$htmlstring .= '&fnl=y';
		}
	}

	if ($HTTP_POST_VARS['show_replies'])
	{
		$htmlstring .= '&r=y';
		if ($HTTP_POST_VARS['show_replies_word'])
		{
			$htmlstring .= '&sr=y';
		}
	}

	if ($HTTP_POST_VARS['show_announce'])
	{
		$htmlstring .= '&a=y';
	}

	if ($HTTP_POST_VARS['show_sticky'])
	{
		$htmlstring .= '&s=y';
	}

	if ($HTTP_POST_VARS['show_locked'])
	{
		$htmlstring .= '&l=y';
	}

	if ($HTTP_POST_VARS['show_moved'])
	{
		$htmlstring .= '&m=y';
	}

	if (!$HTTP_POST_VARS['show_regular'])
	{
		$htmlstring .= '&rt=n';
	}

	if (isset($HTTP_POST_VARS['hidelabel']))
	{
		$htmlstring .= '&h=';
		$hidelabel = $HTTP_POST_VARS['hidelabel'];
		foreach ($hidelabel as $key => $val)
		{
			$htmlstring .= substr($key, 1, -1);
		}
	}

	if ($HTTP_POST_VARS['sort_order'] == 'ondate')
	{
		$htmlstring .= '&so=d';
	}

	if ($out != 'rss') {
		if ($HTTP_POST_VARS['lastposticon_bullet'])
		{
			$htmlstring .= '&b=lpi';
		}
		else
		{
			$htmlstring .= '&b=' . $HTTP_POST_VARS['bullet_type'];
		}
	}

	if ($HTTP_POST_VARS['show_lastpostby'])
	{
		$htmlstring .= '&lpb=' . $HTTP_POST_VARS['lastpostby_format'];
	}

	if ($HTTP_POST_VARS['show_lastpostdate'])
	{
		$htmlstring .= '&lpd=' . $HTTP_POST_VARS['lastpostdate_format'];
	}

	if ($HTTP_POST_VARS['show_lastposticon'] && $out == 'js')
	{
		$htmlstring .= '&lpi=y';
	}

	if ($HTTP_POST_VARS['add_break'] && $out == 'js')
	{
		$htmlstring .= '&br=y';
	}

	if ($HTTP_POST_VARS['add_blank_line'] && $out == 'js')
	{
		$htmlstring .= '&bl=y';
	}

	if (isset($HTTP_POST_VARS['limit_length']))
	{
		if (!is_numeric($HTTP_POST_VARS['limit_length']))
		{
			message_die(GENERAL_ERROR, ($lang['Invalid_title_length'] . '<br /><br /><a href="javascript:history.back()">' . $lang['Click_return'] . '</a>'));
		}
		else
		{
			$limitlength = floor(intval($HTTP_POST_VARS['limit_length']));
			if ($limitlength > 0)
			{
				$htmlstring .= '&ch=' . $limitlength . '&chw=' . $HTTP_POST_VARS['limit_where'];
			}
		}
	}

	if (isset($HTTP_POST_VARS['css_link']) && $out == 'js')
	{
		$css_link = trim($HTTP_POST_VARS['css_link']);
		if (preg_match("/[^a-zA-Z0-9]+$/s", $css_link) || strstr($css_link, ' '))
		{
			message_die(GENERAL_ERROR, ($lang['Invalid_class'] . '<br /><br /><a href="javascript:history.back()">' . $lang['Click_return'] . '</a>'));
		}
		else
		{
			if ($css_link != '')
			{
				$htmlstring .= '&cl=' . $css_link;
			}
		}
	}

	if (isset($HTTP_POST_VARS['css_text']) && $out == 'js')
	{
		$css_text = trim($HTTP_POST_VARS['css_text']);
		if (preg_match("/[^a-zA-Z0-9]+$/s", $css_text) || strstr($css_text, ' '))
		{
			message_die(GENERAL_ERROR, ($lang['Invalid_class'] . '<br /><br /><a href="javascript:history.back()">' . $lang['Click_return'] . '</a>'));
		}
		else
		{
			if ($css_text != '')
			{
				$htmlstring .= '&ct=' . $css_text;
			}
		}
	}

	if (isset($HTTP_POST_VARS['target_link']) && $out == 'js')
	{
		$target_link = trim($HTTP_POST_VARS['target_link']);
		if (preg_match("/[^a-zA-Z0-9_]+$/s", $target_link) || strstr($target_link, ' '))
		{
			message_die(GENERAL_ERROR, ($lang['Invalid_target'] . '<br /><br /><a href="javascript:history.back()">' . $lang['Click_return'] . '</a>'));
		}
		else
		{
			if ($target_link != '')
			{
				$htmlstring .= '&t=' . $target_link;
			}
		}
	}

	if ($HTTP_POST_VARS['adv_form_enable'])
	{
		if (isset($HTTP_POST_VARS['adv_form']))
		{
			if ($out != 'js') {
				$htmlstring .= '&af=' . rawurlencode(base64_encode(strip_tags($HTTP_POST_VARS['adv_form'])));
			}
			else
			{
				include($phpbb_root_path . 'includes/functions_post.'.$phpEx);

				$html_on = (!$board_config['allow_html']) ? 0 : 1;
				$htmlstring .= '&af=' . rawurlencode(base64_encode(prepare_message($HTTP_POST_VARS['adv_form'], $html_on, 0, 0, '')));
			}
		}
	}

	if ($out == 'js')
	{
		$htmlstring = '<script language="JavaScript" type="text/javascript" src="' . $htmlstring . '"></script>';
	}

	$page_title = $lang['Topics_anywhere'];
	include($phpbb_root_path . 'includes/page_header.'.$phpEx);

	if ($out == 'js')
	{
		$file = 'topics_anywhere_result.tpl';
		$result = str_replace("&amp;", "&", htmlspecialchars($htmlstring, ENT_QUOTES));
	}
	else if ($out != 'js')
	{
		$file = 'topics_anywhere_result_rss.tpl';
		$result = '<a href="' . $htmlstring . '" target="_blank" class="gen">' . str_replace("&amp;", "&", htmlspecialchars($htmlstring, ENT_QUOTES)) . '</a>';
		$lang['Copy_paste'] = $lang['Copy_paste_rss'];
		$lang['Copy_paste_explain'] = $lang['Copy_paste_explain_rss'];
	}

	$template->set_filenames(array(
		'body' => $file)
	);


	$template->assign_vars(array(
		'L_TOPICS_ANYWHERE' => $lang['Topics_anywhere'] . ' ' . TA_VERSION,
		'L_COPYPASTE' => $lang['Copy_paste'],
		'L_COPYPASTE_EXPLAIN' => $lang['Copy_paste_explain'],
		'RESULT' => $result,
		'L_RESULT' => $lang['The_result'],
		'L_CLASSES_REMARK' => $lang['Classes_remark'],
		'HTMLCODE' => $htmlstring)
	);

	$template->pparse('body');

	include($phpbb_root_path . 'includes/page_tail.'.$phpEx);
}
else // shows option page - page will be shown if no or wrong $mode arguments are given
{
        if ($topics_anywhere_authlevel == 0)
	{
                show_the_page();
 	}
	else
	{
		if ( !$userdata['session_logged_in'] )
		{
			$header_location = ( @preg_match("/Microsoft|WebSTAR|Xitami/", getenv("SERVER_SOFTWARE")) ) ? "Refresh: 0; URL=" : "Location: ";
			header($header_location . append_sid("login." . $phpEx . "?redirect=" . TA_SCRIPT_NAME . "." . $phpEx, true));
			exit;
		}
		else // user is logged in - check userlevel
		{
			switch($topics_anywhere_authlevel)
			{
				case 1:
					if ($userdata['user_level'] == ADMIN)
					{
						show_the_page();
					}
					else
					{
						$message = sprintf($lang['Sorry_auth_topicsanywhere'], $lang['Auth_Administrators']);
						message_die(GENERAL_MESSAGE, $message, $lang['Not_Authorised']);
					}
					break;
				case 2:
					if ($userdata['user_level'] == MOD)
					{
						show_the_page();
					}
					else
					{
						$message = sprintf($lang['Sorry_auth_topicsanywhere'], $lang['Auth_Moderators']);
						message_die(GENERAL_MESSAGE, $message, $lang['Not_Authorised']);
					}
					break;
				case 3:
					if ($userdata['user_level'] == ADMIN || $userdata['user_level'] == MOD)
					{
						show_the_page();
					}
					else
					{
						$message = sprintf($lang['Sorry_auth_topicsanywhere'], $lang['Auth_Administrators'] . ' ' . strtolower($lang['Or']) . ' ' . $lang['Auth_Moderators']);
						message_die(GENERAL_MESSAGE, $message, $lang['Not_Authorised']);
					}
					break;
				case 4:
					if ($userdata['user_level'] == USER || $userdata['user_level'] == ADMIN || $userdata['user_level'] == MOD)
					{
						show_the_page();
					}
					else
					{
						$message = sprintf($lang['Sorry_auth_topicsanywhere'], $lang['Auth_Registered_Users']);
						message_die(GENERAL_MESSAGE, $message, $lang['Not_Authorised']);
					}
					break;
				default:
					message_die(GENERAL_MESSAGE, $lang['Error']);
					break;
			}
		}
	}
}

// EOF
?>
